from urllib2 import urlopen
from Components.MenuList import MenuList
from Components.Label import Label

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import NumberActionMap
from Components.Input import Input
from Components.Pixmap import Pixmap
from Components.FileList import FileList
from Screens.ChoiceBox import ChoiceBox
from Plugins.Plugin import PluginDescriptor
from Components.ActionMap import ActionMap

from twisted.web.client import getPage, downloadPage
from Plugins.Extensions.VlcPlayer.VlcServerConfig import vlcServerConfig

############################################################
#                                                          #
#   MusicVideos : Coded by pcd@dreamforum.nu, July 2009    #
#                                                          #
############################################################

class Vidtype(Screen):
    skin = """
		<screen position="200,200" size="350,300" title="Music genres" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="200,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="100,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />

		</screen>"""
    def __init__(self, session):
		self.skin = Vidtype.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)

                self.icount = 0
                self.onLayoutFinish.append(self.startSession)

    def startSession(self):
                vidtype =[]
                self.urltype = []
                i = 0
                while i<5:
                      vidtype.append(i)
                      self.urltype.append(i)
                      i = i+1
                
                vidtype[0] = "Country"
                vidtype[1] = "Pop"
                vidtype[2] = "Latin"
                vidtype[3] = "Rock"
                vidtype[4] = "Hip-hop"
             
                self.urltype[0] = "http://music.clevver.com/country-videos"
                self.urltype[1] = "http://www.clevver.com/pop-music-videos.html"
                self.urltype[2] = "http://www.clevver.com/latin-music-videos.html"
                self.urltype[3] = "http://www.clevver.com/rock-music-videos.html"
                self.urltype[4] = "http://www.clevver.com/hip-hop-music-videos.html"
   
                self["list"].setList(vidtype)
    
    def okClicked(self):
		itype = self["list"].getSelectionIndex()
		url = self.urltype[itype]
		self.session.open(Musicvid, url)

class Musicvid(Screen):

    skin = """
		<screen position="100,100" size="550,400" title="Video list" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="500,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="300,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />
		</screen>"""

    def __init__(self, session, url):
		self.skin = Musicvid.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.icount = 0
                self.url = url

                self.onLayoutFinish.append(self.openTest)

    def openTest(self):
           self["info"].setText("Downloading list...")
           furl = self.url
           getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
       if self.icount==0:   
           iurl = []
           iname = []
           surl = []
           self.names = []
           self.urls = []
           start = fpage.find("div id='just_added'")
           finish = fpage.find("--Just Added end --")
     
	   i = 0
	   icount = 0
	   while i<50 and start<finish:
                n2 = fpage.find("<a href=", start)
                if n2>finish:
                       break 
                n3 = fpage.find(">",(n2+4))
                iurl.append(i)
                iurl[i] = fpage[(n2+9):(n3-1)]
                n4 = fpage.find('alt="Watch',(n3+1))
                n5 = fpage.find('Music Video">',(n4+4))
                iname.append(i)
                iname[i] = fpage[(n4+11):(n5-1)]
                n6 = fpage.find('a href',(n5+4))
 
                furl1 = iurl[i]
                f1 = urlopen(furl1)
                fpage1 = f1.read()

                n7 = fpage1.find('name="URL" value')
                n8 = fpage1.find('.asx')
                if n7>0 and n8>0:
                      surl.append(icount)
                      surl[icount] = fpage1[(n7+18):(n8+4)]
                      
                      self.names.append(icount)
                      self.urls.append(icount)        
                      self.names[icount] = iname[i]
                      self.urls[icount] = surl[icount]
                      icount = icount+1 
                start = n6 + 7
            
                i = i+1
           self.icount = 1
           self["info"].setText("")
           self["list"].setList(self.names)
       else:
           self["list"].setList(self.names)    
   
    def test(self, idx):
		if idx is not None:
			self.serverList = vlcServerConfig.getServerlist()
			if len(self.serverList) == 0:
				self.session.open(MessageBox, "No server configured in VlcPlayer Plugin!", MessageBox.TYPE_ERROR)
			elif len(self.serverList) == 1:
				self.playfile(0, idx)
			else:
				self.playfile(0, idx)
		else:
			print "Nothing selected"
			
	
    def playfile(self, serverint, idx):
                if idx is not None:
			self.serverList[serverint].play(self.session, self.urls[idx], self.names[idx])


    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
    def okClicked(self):
		if len(self.names) > 0:
			idx = self["list"].getSelectionIndex()
	                self.test(idx)
 
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)
		
     

def main(session, **kwargs):
        session.open(Vidtype)
        
		

def Plugins(**kwargs):
	return PluginDescriptor(name="MusicVideos", description="Streams music videos from Clevver", where = PluginDescriptor.WHERE_PLUGINMENU, fnc=main)




